/*
    Run this program and use Task Manager (and Sysinternal's Process Explorer)
    to watch its various memory sizes change before and after this process
    trims itself.

    Why does this process begin with "Mem Usage" ("Working Set") greater than
    "VM Size" ("Private Bytes")?

    Compile and run this program both with and without the calls to printf().
    Notice how that affects the various memory sizes.

    Notice that if the first printf() is compiled in, then the final value for
    "Mem Usage" ("Working Set") is 152K vs 148K for "VM Size" ("Private Bytes"),
    but when the first printf() is not compiled into the program, the final value
    for "Mem Usage" ("Working Set") is 172K vs 148K for "VM Size" ("Private Bytes"),
*/
#include <windows.h>
#include <stdio.h>

DWORD minWorkingSetSize = 0xffffffff; // this is -1 in 2s complement form
DWORD maxWorkingSetSize = 0xffffffff;

int main()
{
   printf("process started\n"); // access the C Runtime Library
   Sleep(3000);

   // use a process handle to trim this process's working set
   SetProcessWorkingSetSize( GetCurrentProcess(),
                             minWorkingSetSize,
                             maxWorkingSetSize );

   Sleep(3000);
   printf("process trimmed\n");  // page the C Runtime Library back in

   while(1)
      Sleep(1000);

   return 0;
}
